"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAIExtractorListForUser = exports.getAIExtractorListForCustomization = exports.getAIExtractorColumnsForUser = exports.getAIExtractorColumnsForCustomization = void 0;
var util_1 = require("../../sections/list/util");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var getAIExtractorColumnsForCustomization = function (onClickRecord, entity, settings) {
    var currentSettings = settings ? settings : {};
    var recordInAction = currentSettings.recordInAction, context = currentSettings.context;
    return [
        (0, util_1.getDefaultFirstBodyCell)(onClickRecord, entity, settings),
        (0, util_1.DEFAULT_LIST_EDIT_COLUMN)(onClickRecord, entity, {
            recordInAction: recordInAction,
            context: context
        }),
        (0, util_1.DEFAULT_LIST_ACTION_COLUMN)(onClickRecord, entity, {
            recordInAction: recordInAction,
            context: context
        })
    ];
};
exports.getAIExtractorColumnsForCustomization = getAIExtractorColumnsForCustomization;
var getAIExtractorColumnsForUser = function (onClickRecord, entity, settings) {
    var currentSettings = settings ? settings : {};
    var recordInAction = currentSettings.recordInAction, context = currentSettings.context;
    return [
        (0, util_1.getDefaultFirstBodyCell)(onClickRecord, entity, settings),
        (0, util_1.DEFAULT_LIST_PLAY_COLUMN)(onClickRecord, entity, {
            recordInAction: recordInAction,
            context: context
        })
    ];
};
exports.getAIExtractorColumnsForUser = getAIExtractorColumnsForUser;
var getAIExtractorListForCustomization = function (list, context) {
    (0, primeobjects_helper_util_1.doNothing)({ list: list, context: context });
    return {
        sectionProps: {
            query: { service: "hidden" },
            getColumns: exports.getAIExtractorColumnsForCustomization
        }
    };
};
exports.getAIExtractorListForCustomization = getAIExtractorListForCustomization;
var getAIExtractorListForUser = function (list, context) {
    (0, primeobjects_helper_util_1.doNothing)({ list: list, context: context });
    return {
        sectionProps: {
            query: { service: "hidden", scope: "published" },
            getColumns: exports.getAIExtractorColumnsForUser
        }
    };
};
exports.getAIExtractorListForUser = getAIExtractorListForUser;
//# sourceMappingURL=ai-extractor.js.map