"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PageWrapper = void 0;
var react_1 = __importStar(require("react"));
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
// import NavSectionInternal from "primeobjects-ui-web-application/build/cjs/sections/nav";
var nav_1 = __importDefault(require("../sections/nav"));
var me_modal_1 = __importDefault(require("../sections/modals/me-modal"));
var org_modal_1 = __importDefault(require("../sections/modals/org-modal"));
var solution_modal_1 = __importDefault(require("../sections/modals/solution-modal"));
var lodash_1 = require("lodash");
var util_1 = require("../util");
var colors_1 = require("primeobjects-helper-util/build/cjs/colors");
var NavSection = undefined;
var PageWrapper = function (props) {
    var _a, _b;
    if (!NavSection) {
        console.log("Get global components in /pages/wrapper.tsx");
        NavSection = (0, util_1.getGlobalComponent)("NavSection", nav_1.default);
    }
    var query = props.query, solution = props.solution, host = props.host, url = props.url, domain = props.domain, locale = props.locale, locales = props.locales, UserForm = props.UserForm, OrgForm = props.OrgForm, SolutionForm = props.SolutionForm, AppBasePage = props.AppBasePage, hideNav = props.hideNav, appTrack = props.appTrack, port = props.port, hideNavMeButton = props.hideNavMeButton, allowGuest = props.allowGuest;
    var primaryColor = (0, primeobjects_helper_ui_1.getPrimaryColor)(solution);
    var backgroundColor = (_b = (_a = solution === null || solution === void 0 ? void 0 : solution.app) === null || _a === void 0 ? void 0 : _a.backgroundColor) !== null && _b !== void 0 ? _b : (0, colors_1.hexToRgbaString)(primaryColor["50"], 0.3);
    var _c = (0, react_1.useState)(undefined), showMe = _c[0], setShowMe = _c[1];
    var _d = (0, react_1.useState)(undefined), showOrg = _d[0], setShowOrg = _d[1];
    var _e = (0, react_1.useState)(80), navWidth = _e[0], setNavWidth = _e[1];
    var _f = (0, react_1.useState)(undefined), showSolution = _f[0], setShowSolution = _f[1];
    var onContextReady = function (newContext) {
        props.onContextReady && props.onContextReady(newContext);
    };
    (0, react_1.useEffect)(function () {
        var _a;
        if (showMe !== props.showMeModal) {
            setShowMe((_a = props.showMeModal) !== null && _a !== void 0 ? _a : undefined);
        }
    }, [props.showMeModal]);
    (0, react_1.useEffect)(function () {
        var _a;
        if (showSolution !== props.showSolutionModal) {
            setShowSolution((_a = props.showSolutionModal) !== null && _a !== void 0 ? _a : undefined);
        }
    }, [props.showSolutionModal]);
    (0, react_1.useEffect)(function () {
        var _a;
        if (showOrg !== props.showOrgModal) {
            setShowOrg((_a = props.showOrgModal) !== null && _a !== void 0 ? _a : undefined);
        }
    }, [props.showOrgModal]);
    var onClickMe = function () {
        var v = Date.now();
        setShowMe(v);
        props.onShowMe && props.onShowMe(v);
    };
    var onClickSolution = function () {
        var v = Date.now();
        setShowSolution(v);
        props.onShowSolution && props.onShowSolution(v);
    };
    var onClickOrg = function () {
        var v = Date.now();
        setShowOrg(v);
        props.onShowOrg && props.onShowOrg(v);
    };
    var onCloseMe = function () {
        setShowMe(undefined);
        props.onShowMe && props.onShowMe(undefined);
    };
    var onCloseSolution = function () {
        setShowSolution(undefined);
        props.onShowSolution && props.onShowSolution(undefined);
    };
    var onCloseOrg = function () {
        setShowOrg(undefined);
        props.onShowOrg && props.onShowOrg(undefined);
    };
    var onClickNavItem = function (item) {
        props.onClickNavItem && props.onClickNavItem(item);
    };
    var renderTopArea = function () {
        return props.topArea ? (props.topArea) : (react_1.default.createElement("div", { className: "w-full border-b relative flex flex-row border-".concat(primaryColor.name, "-300"), style: { minHeight: 65, height: 65 } }));
    };
    var onResizeNav = function (width) {
        setNavWidth(width);
    };
    var renderMainArea = function () {
        return (react_1.default.createElement("div", { className: "flex flex-row w-full", style: { backgroundColor: backgroundColor } },
            !hideNav && (react_1.default.createElement(NavSection, { hidden: hideNav, solution: solution, allowGuest: allowGuest, onClickMe: onClickMe, onClickOrg: onClickOrg, onClickSolution: onClickSolution, onClickItem: onClickNavItem, onResize: onResizeNav, hideMeButton: hideNavMeButton, supportResize: props.supportNavResize, fixedSize: props.fixedSizedNavArea })),
            react_1.default.createElement("div", { style: { width: "calc(100% - ".concat(navWidth, "px)") } }, props.mainArea)));
    };
    return (react_1.default.createElement(AppBasePage, { allowGuest: allowGuest, solution: solution, appTrack: appTrack, onContextReady: onContextReady, onClickNavItem: props.onClickNavItem, currentContextSettings: props.currentContextSettings, headProps: __assign(__assign({}, props.headProps), { host: host, url: url, domain: domain, query: query, locale: locale, locales: locales, port: port }), onClickMe: onClickMe, onClickOrg: onClickOrg, onClickSolution: onClickSolution },
        react_1.default.createElement("div", { className: "w-full flex flex-col" },
            renderTopArea(),
            renderMainArea(),
            props.bottomArea),
        react_1.default.createElement(me_modal_1.default, { show: !(0, lodash_1.isNil)(showMe), onClickClose: onCloseMe, Form: UserForm }),
        react_1.default.createElement(org_modal_1.default, { show: !(0, lodash_1.isNil)(showOrg), onClickClose: onCloseOrg, Form: OrgForm }),
        react_1.default.createElement(solution_modal_1.default, { show: !(0, lodash_1.isNil)(showSolution), onClickClose: onCloseSolution, Form: SolutionForm })));
};
exports.PageWrapper = PageWrapper;
exports.default = exports.PageWrapper;
//# sourceMappingURL=wrapper.js.map