"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppTopOrg = void 0;
var react_1 = __importDefault(require("react"));
var svg_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/svg"));
var gradient_div_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/gradient-div"));
var mobx_react_lite_1 = require("mobx-react-lite");
var primeobjects_ui_web_store_1 = require("primeobjects-ui-web-store");
exports.AppTopOrg = (0, mobx_react_lite_1.observer)(function (props) {
    var _a, _b, _c, _d;
    var primaryColor = props.primaryColor;
    var contextStore = (0, primeobjects_ui_web_store_1.useContextStore)();
    var context = JSON.parse(contextStore.data);
    var organization = context.organization;
    var wrapperStyle = (_a = props.wrapperStyle) !== null && _a !== void 0 ? _a : {};
    var wrapperClassName = (_b = props.wrapperClassName) !== null && _b !== void 0 ? _b : "";
    var textWrapperStyle = (_c = props.textWrapperStyle) !== null && _c !== void 0 ? _c : {};
    var textWrapperClassName = (_d = props.textWrapperClassName) !== null && _d !== void 0 ? _d : "";
    return (react_1.default.createElement("div", { className: "flex flex-1 h-full p-2 items-center justify-center leading-none ".concat(props.onClick ? "cursor-pointer" : "", " ").concat(wrapperClassName), style: wrapperStyle, onClick: props.onClick ? props.onClick : function () { } },
        react_1.default.createElement("div", { className: "flex flex-col items-center", style: { width: 36 } },
            react_1.default.createElement(svg_1.default, { size: 36, src: "/icons/app/organization.svg", color: primaryColor["500"] })),
        organization && (react_1.default.createElement("div", { className: "flex flex-col w-full ml-2 ".concat(textWrapperClassName), style: textWrapperStyle },
            react_1.default.createElement("div", { className: "w-full text-xs text-gray-500" }, "Organization"),
            react_1.default.createElement("div", { className: "flex flex-row w-full" },
                react_1.default.createElement(gradient_div_1.default, { className: "w-full leading-5 font-medium text-base text-gray-800" }, organization.name))))));
});
exports.default = exports.AppTopOrg;
//# sourceMappingURL=app-top-org.js.map