"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchSection = void 0;
var react_1 = __importStar(require("react"));
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var svg_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/svg"));
var content_loader_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/content-loader"));
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var SearchSection = function (props) {
    var hideSearchButton = props.hideSearchButton, searching = props.searching, placeholder = props.placeholder, cancelSearch = props.cancelSearch;
    var _a = (0, react_1.useState)(""), keywords = _a[0], setKeywords = _a[1];
    var inputClassName = props.inputClassName ? props.inputClassName : "";
    var inputStyle = props.inputStyle ? props.inputStyle : {};
    var wrapperClassName = props.wrapperClassName
        ? props.wrapperClassName
        : "";
    var wrapperStyle = props.wrapperStyle ? props.wrapperStyle : {};
    var INPUT_MIN_WIDTH = 100;
    (0, react_1.useEffect)(function () {
        if (cancelSearch)
            onCancelSearch();
    }, [cancelSearch]);
    var onChangeSearch = function (e) {
        setKeywords(e.target.value);
        if (props.onChange)
            props.onChange("");
    };
    var onSubmitSearch = function () {
        if (props.onSubmit)
            props.onSubmit(keywords);
    };
    var onCancelSearch = function () {
        setKeywords("");
        if (props.onSubmit)
            props.onSubmit("");
    };
    var onKeyDown = function (event) {
        if (event.key === "Enter") {
            event.preventDefault();
            event.stopPropagation();
            onSubmitSearch();
        }
    };
    return (react_1.default.createElement("div", { className: "w-full flex flex-row items-center relative ".concat(wrapperClassName), style: wrapperStyle }, searching ? (react_1.default.createElement(content_loader_1.default, { id: "search-loader", height: 32, count: 3, width: INPUT_MIN_WIDTH, barHeight: 6 })) : (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("input", { value: keywords, placeholder: placeholder ? placeholder : "Search ...", className: "w-full border-0 text-base ".concat(searching ? "hidden" : "", " ").concat(inputClassName), style: __assign({ height: 32, minWidth: INPUT_MIN_WIDTH, marginRight: 5, width: "calc(100% - ".concat((!(0, core_1.isNonEmptyString)(keywords) ? 0 : 38) +
                    (hideSearchButton ? 0 : 30), "px)") }, inputStyle), onKeyDown: onKeyDown, onChange: onChangeSearch }),
        (0, core_1.isNonEmptyString)(keywords) && (react_1.default.createElement(svg_1.default, { src: "/icons/platform/x.svg", size: 16, color: primeobjects_helper_util_1.COLORS.GRAY["500"], onClick: onCancelSearch, style: { marginTop: -5 }, className: "mx-2 cursor-pointer" })),
        !hideSearchButton && (react_1.default.createElement(svg_1.default, { src: "/icons/platform/search.svg", size: 24, onClick: onSubmitSearch, className: "cursor-pointer" }))))));
};
exports.SearchSection = SearchSection;
exports.default = exports.SearchSection;
//# sourceMappingURL=search.js.map