"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteMainSection = void 0;
var react_1 = __importDefault(require("react"));
var img_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/img"));
var site_section_1 = __importDefault(require("./site-section"));
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var site_intro_1 = __importDefault(require("./site-intro"));
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var SiteMainSection = function (props) {
    var introductionProps = props.introductionProps, imageUrl = props.imageUrl, style = props.style, solution = props.solution;
    var colorName = (0, primeobjects_helper_ui_1.usePrimaryColorName)();
    if (!(0, primeobjects_helper_util_1.isNonEmptyString)(introductionProps.colorName))
        introductionProps.colorName = colorName;
    var className = (0, primeobjects_helper_util_1.isNonEmptyString)(props.className) ? props.className : "";
    return (react_1.default.createElement(site_section_1.default, { className: "relative ".concat(className), style: style },
        react_1.default.createElement("div", { className: "max-w-7xl mx-auto" },
            react_1.default.createElement("div", { className: "relative z-10 pb-8 bg-white sm:pb-16 md:pb-20 lg:max-w-2xl lg:w-full lg:pb-28 xl:pb-32" },
                react_1.default.createElement("div", { className: "flex flex-col mx-auto max-w-7xl pt-20" },
                    react_1.default.createElement(site_intro_1.default, __assign({}, introductionProps, { colorName: colorName, solution: solution }))))),
        react_1.default.createElement("div", { className: "lg:absolute top-0 lg:inset-y-0 lg:right-0 lg:w-1/2" },
            react_1.default.createElement(img_1.default, { className: "h-56 w-full object-cover sm:h-72 md:h-96 lg:w-full lg:h-full transition-all duration-1000 ease-in-out opacity-100", src: imageUrl, alt: "" }))));
};
exports.SiteMainSection = SiteMainSection;
exports.default = exports.SiteMainSection;
//# sourceMappingURL=site-main.js.map