//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import React, { useEffect, useState } from "react";
import { libTrackIsOn, isNonEmptyString } from "primeobjects-helper-util/build/cjs/core";
import { getAcceptExtension } from "primeobjects-helper-util/build/cjs/file";
import { ResizeDetectorDiv, SVG } from "primeobjects-ui-web-basic";
import { callApi } from "../context/auth-call-api";
import { getApiEndpoint, uploadToS3 } from "../util";
import { usePrimaryColor, useSolution } from "primeobjects-helper-ui";
import Popconfirm from "./antd/popconfirm";
import { Upload } from "antd";
import { isFunction, assign, find } from "lodash";
import Tooltip from "./antd/tooltip";
//NOTE:
//If you run into "The bucket does not allow ACLs" error when uploading the file
//Go to the "Edit Object Ownership" page of S3 bucket settings from the url below
//https://s3.console.aws.amazon.com/s3/bucket/bandup-us-prod-document/property/oo/edit?region=us-east-1
//Enable ACL
function getBase64(file) {
    return new Promise(function (resolve, reject) {
        var reader = new FileReader();
        reader.readAsDataURL(file);
        reader.onload = function () { return resolve(reader.result); };
        reader.onerror = function (error) { return reject(error); };
    });
}
function getContent(file) {
    return new Promise(function (resolve, reject) {
        var reader = new FileReader();
        reader.readAsText(file);
        reader.onload = function () { return resolve(reader.result); };
        reader.onerror = function (error) { return reject(error); };
    });
}
export var Uploader = function (props) {
    var entityName = props.entityName, recordId = props.recordId, attributeName = props.attributeName, label = props.label, fileNamePrefix = props.fileNamePrefix, autoPreviewResize = props.autoPreviewResize, signedUrlFormat = props.signedUrlFormat, fileType = props.fileType, iconUrl = props.iconUrl, disabled = props.disabled;
    var solution = useSolution();
    var _a = useState(0), width = _a[0], setWidth = _a[1];
    var resultType = props.resultType ? props.resultType : "upload";
    var wrapperClassName = props.wrapperClassName
        ? props.wrapperClassName
        : "";
    var wrapperStyle = props.wrapperStyle ? props.wrapperStyle : {};
    var uploadControlWrapperClassName = props.uploadControlWrapperClassName
        ? props.uploadControlWrapperClassName
        : "";
    var uploadControlWrapperStyle = props.uploadControlWrapperStyle
        ? props.uploadControlWrapperStyle
        : {};
    var _b = useState([]), files = _b[0], setFiles = _b[1];
    var _c = useState(""), error = _c[0], setError = _c[1];
    var _d = useState(false), uploading = _d[0], setUploading = _d[1];
    var _e = useState(""), previewValue = _e[0], setPreviewValue = _e[1];
    var _f = useState(0), previewSizeRatio = _f[0], setPreviewSizeRatio = _f[1];
    var signedUrlSize = props.signedUrlSize ? props.signedUrlSize : "1440";
    var hideLabel = props.hideLabel || !isNonEmptyString(label);
    var primaryColor = usePrimaryColor();
    var hideDeleteButton = props.hideDeleteButton == true;
    var iconStyle = __assign({ width: 30, height: 30 }, props.iconStyle);
    var uiFormat = props.uiFormat == "photo" ? "photo" : "icon";
    useEffect(function () {
        if (previewValue.indexOf("base64,") < 0) {
            setPreviewValue(props.value && isNonEmptyString(props.value) ? props.value : "");
        }
    }, [props.value]);
    useEffect(function () {
        setPreviewValue(props.value && isNonEmptyString(props.value) ? props.value : "");
    }, [props.recordId, attributeName, entityName]);
    useEffect(function () {
        if (previewValue &&
            isNonEmptyString(previewValue) &&
            autoPreviewResize == true) {
            var img_1 = new Image();
            img_1.onload = function () {
                //console.log("Preview image success");
                setPreviewSizeRatio((1.0 * img_1.height) / img_1.width);
            };
            // img.onerror = () => {
            //    //keep trying the url
            //    console.log("Preview image failed.");
            //    setTimeout(()=>{
            //        setPreviewValue(setWebQueryValue(previewValue,"retry",newGuid()));
            //    },1000);
            // }
            img_1.src = previewValue;
        }
        else {
            setPreviewSizeRatio(0);
        }
    }, [previewValue]);
    var onResize = function (newWidth) {
        setWidth(newWidth ? newWidth : 0);
    };
    var photoStyle = uiFormat == "photo" &&
        fileType == "Photo" &&
        isNonEmptyString(previewValue)
        ? { backgroundImage: "url(".concat(previewValue, ")") }
        : {};
    var photoSizeStyle = width > 0 && previewSizeRatio > 0
        ? { height: width * previewSizeRatio }
        : {};
    var onBeforeUpload = function (file, files) {
        if (isFunction(props.onStart))
            props.onStart(file, files);
        return false;
    };
    var getAccept = function () {
        if (props.accept && isNonEmptyString(props.accept))
            return props.accept;
        return getAcceptExtension(fileType);
    };
    var onContentOnly = function (result) { return __awaiter(void 0, void 0, void 0, function () {
        var fileContent;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setError("");
                    return [4 /*yield*/, getContent(result.file)];
                case 1:
                    fileContent = _a.sent();
                    if (isFunction(props.onSuccess))
                        props.onSuccess({ content: fileContent });
                    return [2 /*return*/];
            }
        });
    }); };
    var onUpload = function (result, includeContent) { return __awaiter(void 0, void 0, void 0, function () {
        var rawBase64Data, track, base64Data, fName, fNameInfo, fExt, fileName, ext, s3Setting, cfSignedResult, cfSignedRawResult, _a, url, rawUrl, url, fileContent, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, getBase64(result.file)];
                case 1:
                    rawBase64Data = _c.sent();
                    track = libTrackIsOn();
                    base64Data = rawBase64Data.replace(/^data:image\/[\w|\-]+;base64,/, "");
                    base64Data = base64Data.replace(/^data:text\/[\w|\-]+;base64,/, "");
                    base64Data = base64Data.replace(/^data:application\/[\w|\-]+;base64,/, "");
                    if (track)
                        console.log({ rawBase64Data: rawBase64Data, base64Data: base64Data });
                    base64Data = Buffer.from(base64Data, "base64");
                    fName = fileNamePrefix
                        ? "".concat(fileNamePrefix, ".").concat(result.file.name)
                        : result.file.name;
                    fNameInfo = fName.split(".");
                    fExt = fNameInfo.pop(0);
                    fileName = (fNameInfo.join(".").replace(/[^a-z0-9-]/gi, "_") +
                        "." +
                        fExt).toLowerCase();
                    ext = fileName
                        .split(".")[fileName.split(".").length - 1].toLowerCase();
                    if (!find(getAccept().split(","), function (a) {
                        var as = a.trim().split(".");
                        return as.length > 1 && as[1].toLowerCase() == ext;
                    })) {
                        alert("The file tyle (".concat(ext, ") is not supported"));
                        return [2 /*return*/];
                    }
                    if (track)
                        console.log({ fileName: fileName });
                    return [4 /*yield*/, callApi(solution, getApiEndpoint(solution, "file", "upload-setting", entityName), { fileName: fileName, entityName: entityName, recordId: recordId, attributeName: attributeName, fileType: fileType }, "GET")];
                case 2:
                    s3Setting = _c.sent();
                    if (track)
                        console.log({ s3Setting: s3Setting });
                    return [4 /*yield*/, uploadToS3(s3Setting.url, s3Setting.s3FileName, base64Data)];
                case 3:
                    _c.sent();
                    cfSignedResult = null;
                    cfSignedRawResult = null;
                    _a = fileType;
                    switch (_a) {
                        case "Photo": return [3 /*break*/, 4];
                    }
                    return [3 /*break*/, 8];
                case 4:
                    url = "".concat(solution.cloudFront.photo).concat(s3Setting.s3FileName).concat(signedUrlSize == "raw"
                        ? ""
                        : ".resized." + signedUrlSize + ".jpg").concat(signedUrlFormat == "original" || signedUrlSize == "raw"
                        ? ""
                        : ".webp");
                    return [4 /*yield*/, callApi(solution, getApiEndpoint(solution, "file", "cf-signed-url", entityName), { url: url }, "GET")];
                case 5:
                    cfSignedResult = _c.sent();
                    if (!(signedUrlSize != "raw")) return [3 /*break*/, 7];
                    rawUrl = "".concat(solution.cloudFront.photo).concat(s3Setting.s3FileName);
                    return [4 /*yield*/, callApi(solution, getApiEndpoint(solution, "file", "cf-signed-url", entityName), { url: rawUrl }, "GET")];
                case 6:
                    cfSignedRawResult = _c.sent();
                    _c.label = 7;
                case 7:
                    setPreviewValue(rawBase64Data);
                    return [3 /*break*/, 10];
                case 8:
                    url = "".concat(solution.cloudFront[fileType.toLocaleLowerCase()]).concat(s3Setting.s3FileName);
                    return [4 /*yield*/, callApi(solution, getApiEndpoint(solution, "file", "cf-signed-url", entityName), { url: url }, "GET")];
                case 9:
                    cfSignedResult = _c.sent();
                    return [3 /*break*/, 10];
                case 10:
                    if (track)
                        console.log({ cfSignedResult: cfSignedResult });
                    if (!(includeContent == true)) return [3 /*break*/, 12];
                    return [4 /*yield*/, getContent(result.file)];
                case 11:
                    _b = _c.sent();
                    return [3 /*break*/, 13];
                case 12:
                    _b = null;
                    _c.label = 13;
                case 13:
                    fileContent = _b;
                    if (isFunction(props.onSuccess))
                        props.onSuccess(assign({ s3Setting: s3Setting, cfSignedResult: cfSignedResult, cfSignedRawResult: cfSignedRawResult }, fileContent ? { content: fileContent } : {}));
                    return [2 /*return*/];
            }
        });
    }); };
    var onAfterUpload = function (result) { return __awaiter(void 0, void 0, void 0, function () {
        var _a, error_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    setFiles(result.fileList);
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 9, 10, 11]);
                    setUploading(true);
                    setError("");
                    _a = resultType;
                    switch (_a) {
                        case "content": return [3 /*break*/, 2];
                        case "both": return [3 /*break*/, 4];
                    }
                    return [3 /*break*/, 6];
                case 2: return [4 /*yield*/, onContentOnly(result)];
                case 3:
                    _b.sent();
                    return [3 /*break*/, 8];
                case 4: return [4 /*yield*/, onUpload(result, true)];
                case 5:
                    _b.sent();
                    return [3 /*break*/, 8];
                case 6: return [4 /*yield*/, onUpload(result, false)];
                case 7:
                    _b.sent();
                    return [3 /*break*/, 8];
                case 8: return [3 /*break*/, 11];
                case 9:
                    error_1 = _b.sent();
                    console.error(error_1);
                    setError("Failed to upload.");
                    if (isFunction(props.onError))
                        props.onError(error_1);
                    return [3 /*break*/, 11];
                case 10:
                    setFiles([]);
                    setUploading(false);
                    return [7 /*endfinally*/];
                case 11: return [2 /*return*/];
            }
        });
    }); };
    var renderPhotoUI = function () {
        if (uiFormat != "photo")
            return null;
        return (React.createElement(React.Fragment, null,
            files.length == 0 && (React.createElement("div", { className: "flex flex-col items-center p-2", style: { background: "rgba(255,255,255,0.8)" } },
                React.createElement(SVG, { src: "/icons/platform/upload-to-cloud.svg", style: iconStyle }),
                !isNonEmptyString(error) && !hideLabel && (React.createElement("div", { className: "mt-1 text-sm" }, label ? label : "Upload")),
                isNonEmptyString(error) && !hideLabel && (React.createElement("div", { className: "mt-1 text-center text-xs text-red-600 p-2" }, error)))),
            uploading && (React.createElement("div", { className: "flex flex-col items-center p-2", style: { background: "rgba(255,255,255,0.8)" } },
                React.createElement(SVG, { src: "/icons/platform/upload-to-cloud.svg", className: "spinner", style: iconStyle })))));
    };
    var renderIconUI = function () {
        if (uiFormat != "icon")
            return null;
        return (React.createElement(React.Fragment, null,
            files.length == 0 && !uploading && (React.createElement(Tooltip, { color: primaryColor["500"], placement: "bottom", title: label ? label : "Upload" },
                React.createElement(SVG, { src: iconUrl !== null && iconUrl !== void 0 ? iconUrl : "/icons/platform/upload-to-cloud.svg", style: iconStyle, color: error ? "#ff0000" : "#000000" }))),
            uploading && (React.createElement("div", { className: "flex flex-col items-center" },
                React.createElement(SVG, { className: "spinner", src: "/icons/platform/upload-to-cloud.svg", style: iconStyle })))));
    };
    var onConfirmRemove = function () {
        setPreviewValue("");
        if (isFunction(props.onRemove))
            props.onRemove();
    };
    return (React.createElement(ResizeDetectorDiv, { onDetect: onResize, className: "uploader-wrapper flex flex-col h-full w-full content-center bg-cover bg-center relative border overflow-hidden ".concat(wrapperClassName), style: __assign(__assign(__assign({}, photoStyle), photoSizeStyle), wrapperStyle) },
        React.createElement("div", { className: "flex flex-row items-center justify-center ".concat(uploadControlWrapperClassName), style: __assign({ width: "100%", height: "100%" }, uploadControlWrapperStyle) },
            React.createElement(Upload, { accept: getAccept(), listType: "text", onChange: onAfterUpload, disabled: files.length > 0 || disabled == true, beforeUpload: onBeforeUpload, fileList: [], maxCount: 1 },
                renderPhotoUI(),
                renderIconUI())),
        !isNonEmptyString(error) &&
            isNonEmptyString(previewValue) &&
            !hideDeleteButton && (React.createElement(Popconfirm, { placement: "top", title: "Remove the photo?", okType: "danger", onConfirm: onConfirmRemove, okText: "Remove", cancelText: "Cancel" },
            React.createElement("div", { className: "text-2xs text-white absolute py-1 px-2 cursor-pointer m-1", style: {
                    background: "rgba(255,0,0,0.5)",
                    right: 0,
                    bottom: 0
                } }, "Delete")))));
};
export default Uploader;
//# sourceMappingURL=uploader.js.map