//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
import React, { useEffect, useState, useRef } from "react";
import SiteErrorSection from "../sections/site-error";
import SiteBasePage from "../page/site-base";
import { callApiBase } from "../util";
import { getRootDomainFromUrl, getWindow } from "primeobjects-helper-util";
import SitePageSplit from "../sections/site-page-split";
import { setSolution } from "primeobjects-helper-ui/build/cjs/hooks/solution";
export var Custom404Page = function (props) {
    var url = props.url, host = props.host, solutionApiEndpoint = props.solutionApiEndpoint;
    var _a = useState(""), domain = _a[0], setDomain = _a[1];
    var solution = useRef(null);
    var message = props.message
        ? props.message
        : "Sorry, we couldn't find the page you’re looking for.";
    var title = props.title ? props.title : "404 - Page Not Found";
    useEffect(function () {
        if (!solution.current) {
            try {
                var domain_1 = getRootDomainFromUrl("".concat(getWindow().location));
                callApiBase("".concat(solutionApiEndpoint, "current-solution"), { domain: domain_1 }, "GET").then(function (result) {
                    setSolution(result);
                    solution.current = result;
                    setDomain(domain_1);
                });
            }
            catch (err) {
                console.error(err);
            }
        }
    }, []);
    return domain.length > 0 && solution.current ? (React.createElement(SiteBasePage, { solution: solution.current, headProps: { host: host, url: url, title: title, domain: domain }, navigation: [] },
        React.createElement(SitePageSplit, null,
            React.createElement(SiteErrorSection, { message: message })))) : (React.createElement(React.Fragment, null));
};
export default Custom404Page;
//# sourceMappingURL=404.js.map